<?php
namespace Incoviba\Repository\Proyecto;

use Incoviba\Common\Ideal;
use Incoviba\Common\Define;
use Incoviba\Common\Implement;
use Incoviba\Repository;
use Incoviba\Model;

class TipoEstadoProyecto extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Etapa $etapaRepository)
    {
        parent::__construct($connection);
        $this->setTable('tipo_estado_proyecto');
    }

    public function create(?array $data = null): Model\Proyecto\TipoEstadoProyecto
    {
        $map = (new Implement\Repository\MapperParser(['descripcion', 'orden']))
            ->register('etapa', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    return $this->etapaRepository->fetchById($data['etapa']);
                }));
        return $this->parseData(new Model\Proyecto\TipoEstadoProyecto(), $data, $map);
    }
    public function save(Define\Model $model): Model\Proyecto\TipoEstadoProyecto
    {
        $model->id = $this->saveNew(['descripcion', 'orden', 'etapa'], [$model->descripcion, $model->orden, $model->etapa->id]);
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Model\Proyecto\TipoEstadoProyecto
    {
        return $this->update($model, ['descripcion', 'orden', 'etapa'], $new_data);
    }
}
